// u_02_delphi_routines
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_02_delphi_routines;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

    type c_person=
             class
               m_first_name: String;
               m_age: integer;

               Constructor create_person(
                   p_first_name: String; p_age: Integer);
             end; // c_person

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    procedural_type_: TButton;
    procedure_of_object_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure procedural_type_Click(Sender: TObject);
    procedure procedure_of_object_Click(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure dClick(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure display_person(p_c_person: c_person);

  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // type t_ft_function= Function(p_x: System.Extended): System.Extended;
    type t_ft_function= Function(p_x: Double): Double;

    function f_integrate(p_ft_function: t_ft_function; p_a, p_b: Double): Double;
      begin

      end; // f_integrate

    function f_sine(p_x: Double): Double;
      begin
        Result:= Sin(p_x);
      end; // f_sine

    procedure TForm1.procedural_type_Click(Sender: TObject);
      var l_result: Double;
      begin
        l_result:= f_integrate(f_sine, 1, 2);
      end; // procedural_type_Click

    // -- procedure of object

    constructor c_person.create_person(p_first_name: String; p_age: Integer);
      begin
        m_first_name:= p_first_name;
        m_age:= p_age;
      end; // create_person

    procedure TForm1.display_person(p_c_person: c_person);
      begin
        display(Format('person=%s, Self.Classname= %s',
            [p_c_person.m_first_name, Self.ClassName]));
      end; // display_person


    type t_po_display_person= procedure(p_c_person: c_person) of Object;

    procedure TForm1.procedure_of_object_Click(Sender: TObject);
      var l_c_person: c_person;
          l_po_display_person: t_po_display_person;
      begin
        l_c_person:= c_person.create_person('joe', 33);

        display_person(l_c_person);

        l_po_display_person:= display_person;
        l_po_display_person(l_c_person);

        l_c_person.Free;
      end; // procedure_of_object_Click

    procedure TForm1.cClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.dClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    { c_person }

end.

